package org.sazabi.util.bijection

import com.twitter.bijection.Injection

import scala.util.control.Exception.allCatch

trait ScalaMathInjections {
  implicit val intToBigIntInjection: Injection[Int, BigInt] =
    Injection.build[Int, BigInt](BigInt(_))(allCatch opt _.intValue)

  implicit val longToBigIntInjection: Injection[Long, BigInt] =
    Injection.build[Long, BigInt](BigInt(_))(allCatch opt _.longValue)

  implicit val bigIntToStringInjection: Injection[BigInt, String] =
    Injection.build[BigInt, String](_.toString)(allCatch opt BigInt(_))

  implicit val bigIntToByteArrayInjection: Injection[BigInt, Array[Byte]] =
    Injection.build[BigInt, Array[Byte]](_.toByteArray)(allCatch opt BigInt(_))

  implicit val intToBigDecimalInjection: Injection[Int, BigDecimal] =
    Injection.build[Int, BigDecimal](BigDecimal(_))(allCatch opt _.intValue)

  implicit val longToBigDecimalInjection: Injection[Long, BigDecimal] =
    Injection.build[Long, BigDecimal](BigDecimal(_))(allCatch opt _.longValue)

  implicit val floatToBigDecimalInjection: Injection[Float, BigDecimal] =
    Injection.build[Float, BigDecimal](BigDecimal(_))(allCatch opt _.floatValue)

  implicit val doubleToBigDecimalInjection: Injection[Double, BigDecimal] =
    Injection.build[Double, BigDecimal](BigDecimal(_))(allCatch opt _.doubleValue)

  implicit val bigDecimalToStringInjection: Injection[BigDecimal, String] =
    Injection.build[BigDecimal, String](_.toString)(allCatch opt BigDecimal(_))

  implicit val bigIntToBigDecimalInjection: Injection[BigInt, BigDecimal] =
    Injection.build[BigInt, BigDecimal](BigDecimal(_))(_.toBigIntExact)
}

object math extends ScalaMathInjections
